function out = plot_dealII_solution_2D(filename, style)
% Diese Funktion zeichnet die Lsung welche deal.II mit der Funktion
% 'Output_for_MatLab_2D::ready_for_MatLab(...)' als Textdatei liefert.
% filename = Der Name der Textdatei mit Endung *.txt
% style = 'mesh' oder 'surf'
% z.B. 'plot_dealII_solution_2D('solution_for_MatLab.txt', 'surf')'

data = load(filename);

%temporrer Speicher
xTemp = data(:,1);
yTemp = data(:,2);
zTemp = data(:,3); 

j = 1;
%Erstellung der Matrizen X,Y,Z, wie sie fr den Befehl 'patch'
%bentigt werden
for( i = 1:1:(length(xTemp)/4))
    X(:,i) = xTemp(j:j+3);
    Y(:,i) = yTemp(j:j+3);
    Z(:,i) = zTemp(j:j+3);
    j = j+4;
end

%Entscheidung welcher Style benutzt wird
if (style == 'mesh')
    face_color = 'none';
elseif (style == 'surf')
    face_color = 'r';
end


patch('XData',X, 'YData',Y, 'ZData',Z,...
      'FaceColor',face_color, 'EdgeColor','k')
grid on;
view(3)