using namespace dealii;

class Laplace_variations 
{
  public:
    Laplace_variations ();	     
    void run ();
   
				     
  private:
	//Variable speichert Nummer des ausgewhlten Gitters
	unsigned int gridChoice;
		
    void make_grid_and_dofs ();
    void assemble_system ();
    void solve ();
    void output_results () const;
    void make_hyper_shell_grid (Triangulation<2> &triangulation, int refinement_level);
    void make_two_boxes_grid (Triangulation<2> &tria);
    void make_grid_with_hole (Triangulation<2> &tria, int refinement_level);

	void show_type_of_pointer(void* object);
				     
    Triangulation<2>     triangulation;
    FE_Q<2>              fe;
    DoFHandler<2>        dof_handler;

    SparsityPattern      sparsity_pattern;
    SparseMatrix<double> system_matrix;

    Vector<double>       solution;
    Vector<double>       system_rhs;
};
