#include <base/function.h>
//Dieser Header enthlt den Header 'Point.h'
#include <base/quadrature_lib.h>
#include "../include/Boundary_Values.h"

//Zweites Argument ist nur Typ, da Name und Defaultwert im Header festgelegt ist
double Boundary_Values::value(const Point<2> &p, const unsigned int ) const
{
	double x = p(0);
	double y = p(1);
	
	//Untere und obere Grenze
	if(y==0){
		return x;
	} else if(y==1){
		return 2-std::pow(x-1,2);
	}
	
	//Linke und rechte Grenze
	if(x==0){
		return y;
	} else if(x==1){
		return 1+y;
	}
	
				
	//Innere Kreisgrenze
	Point<2> center(0.5,0.5);
	const Point<2> vector_to_center = (p - center);
	const double distance_to_center = std::sqrt(vector_to_center.square());
	if(distance_to_center == 0.25){
		return 5;
	}
	
	//Bei der obigen Festlegung der inneren Randdaten kann es zu Problemen kommen,
	//da durch Rundungsfehler Punkte nicht auf dem inneren Rand erkannt werden!
	//Fehlertoleranzbereich [-0.01, 0.01]
	double residual = distance_to_center-0.25;
	if(residual<0.01 && residual >-0.01){
		return 5;	
	}
	
	
	return 0;
}

