#include <iostream>
#include <fstream>
#include <cstdlib>

#include <fe/fe_q.h>
#include <dofs/dof_accessor.h>
#include <numerics/vectors.h>
#include <lac/vector_memory.h>

#include "../include/Output_for_MatLab_2D.h"

Output_for_MatLab_2D::Output_for_MatLab_2D(){
	//nichts
}

/*
	Diese Methode gibt eine Textdatei aus, welche die Lsungsdaten in einem bestimmten
	fr MatLab gnstiges Format enthlt. Diese kann dann mit der mitgelieferten MatLab-Funktion
	'plot_dealII_solution_2D.m' ausgegeben werden.
*/
void Output_for_MatLab_2D::ready_for_MatLab(std::ofstream &outputMatLab,
										 const DoFHandler<2> &dof_handler, 
										 const Vector<double> &solution)
{
	DoFHandler<2>::active_cell_iterator cell = dof_handler.begin_active(),
										endc = dof_handler.end();
	//Temporrer Speicher fr dofs der Ecken einer Zelle						
	std::vector<unsigned int> dof_indices (4);
	
	for(; cell != endc; cell++){
		//Ermitteln der dofs der Ecken der Zelle 'cell'
		cell->get_dof_indices (dof_indices);
		
		int dofs_per_cell = 4;
		for(int i = 0; i<dofs_per_cell ; i++){
			// Ecke 0: x y z
			// Ecke 1: x y z
			// ...
			outputMatLab<<cell->vertex(i)(0)<<" "<<cell->vertex(i)(1)<<" "<<solution(dof_indices[i])<<std::endl;
		}
		outputMatLab<<std::endl;
		
	}
}

